<?php
class moneybooker
{
	var $logfile='moneybookerlog.txt';
	var $form=array();
	var $log=0;
	var $form_action='https://www.moneybookers.com/app/payment.pl';
	var $moneybookersurl='www.moneybookers.com';
	var $posted_data=array();
	var $action='';
	var $error='';
	var $ipn='';
	var $price=0;
	var $payment_success=0;
	var $language = 'EN';
	var $currency_code;
	var $moneybookers_email;
	var $moneybookers_merchant_id;
	var $moneybookers_language;
	var $moneybookers_secret_word = '';

	function __construct() 
	{
		$this->currency_code = APP_CURRENCY_CODE;
		$this->moneybookers_email = APP_MONEYBOOKERS_EMAIL_ADDRESS;
		$this->moneybookers_merchant_id = APP_MONEYBOOKERS_MERCHANT_ID;
		$this->moneybookers_language = APP_MONEYBOOKERS_LANGUAGE;
		$this->moneybookers_secret_word = APP_MONEYBOOKERS_SECRET_WORD;
		
	}
	function set_to_test()
	{
		$this->form_action = 'http://www.moneybookers.com/app/test_payment.pl'; 
		return true;
	}
	
	function moneybooker($price_item=0)
	{
		$this->price=$price_item;
	}

	function validate_ipn()
	{
		if(!empty($_POST))
		{
			foreach($_POST as $key=>$value)
			{
				$this->posted_data[$key]=$value;
			}
			
			// check if merchant ID matches
			$err = $this->_check_Merchant();
			if (!$err)
				return false;
			
			// validate md5signature (not implemented yet)
			$err = $this->_check_md5sig();
			if (!$err)
				return false;
			
			return true;
		}
		
		return false;
	}
	
	function _check_Merchant() {

		// does merchant ID exists ?
		if (!isset ($this->posted_data['merchant_id']) || $this->posted_data['merchant_id'] != $this->moneybookers_email) {
			$this->error = 'merchant id does not match ';
			return false;
		}
		// merchant mail ?
		if (!isset ($this->posted_data['pay_to_email']) || $this->posted_data['pay_to_email'] != $this->moneybookers_email) {
			$this->error = 'merchant email does not match';
			return false;
		}

		return true;
	}
	
	function _check_md5sig() {

		if ($this->moneybookers_secret_word == '')
			return true;

		$secret = $this->moneybookers_secret_word;
		$md5sec = strtoupper(md5($secret));
		$hash = $this->posted_data['merchant_id'] . $this->posted_data['transaction_id'] . $md5sec . $this->posted_data['mb_amount'] . $this->posted_data['mb_currency'] . $this->posted_data['status'];
		$hash = strtoupper(md5($hash));
		if ($hash != $this->posted_data['md5sig']) {
			$this->error = 'md5 signature does not match';
			return false;
		}

		return true;

	}

	function add($name,$value)
	{
		$this->form[$name]=$value;
	}

	function remove($name)
	{
		unset($this->form[$name]);
	}

	function output_form()
	{

		$form = '<form name="f" action="'.$this->form_action.'" method="post">';

		foreach($this->form as $k=>$v)
		{
			$form .= '<input type="hidden" name="' . $k . '" value="' . $v . '" />';
		}

		$form .= '<input class="crtbtn_gr" type="submit" value="Click here if you are not redirected within 10 seconds" /></form>';

		return $form;
	}

	function reset_form()
	{
		$this->form=array();
	}

	function log_results($var)
	{
		$fp=@ fopen($this->logfile,'a');
		$data=date('m/d/Y g:i A');
		if($var==1)
		{
			$str="\nIPN MONEYBOOKERS TRANSACTION ID: " . $this->posted_data['mb_transaction_id'] ."\n";
			$str.="SUCCESS\n";
			$str.="DATE: ". $data . "\n";
			$str.="PAYER EMAIL: " . $this->posted_data['pay_from_email']. "\n";
			$str.="LINK ID: ". $this->posted_data['transaction_id']. "\n";
			$str.="TOTAL: "   . $this->posted_data['mb_amount']. "\n\n\n";
		}
		else
		{
			$str="\nIPN MONEYBOOKERS TRANSACTION ID:\n";
			$str.="INVALID\n";
			$str.="REMOTE IP: " . $_SERVER['REMOTE_ADDR'] . "\n";
			$str.="ERROR: ". $this->error . "\n";
			$str.="DATE: ". $data . "\n";
			$str.="PAYER EMAIL: " . $this->posted_data['pay_from_email']. "\n";
			$str.="LINK ID: ". $this->posted_data['transaction_id']. "\n";
			$str.="TOTAL: "   . $this->posted_data['mb_amount']. "\n\n\n";
		}
		if($fp)
		@ fputs($fp,$str);

		@ fclose($fp);
	}

	function headers_nocache()
	{
		header('Expires: Sat, 26 Jul 1997 05:00:00 GMT');
		header('Cache-Control: no-store, no-cache, must-revalidate');
		header('Cache-Control: pre-check=0, post-check=0, max-age=0');
		header('Pragma: no-cache');
	}


}
