<?php if ( ! defined('APP_ABSPATH')) exit('No direct script access allowed');
/*
*	THIS CLASS IS USED TO SANITIZE THE DATA IN THE $_POST AND $_GET VARIABLES
*/
class Input {
	private $_get = array();
	private $_post = array();
	function __construct()
	{
		$this->_get = $_GET;
		$this->_post = $_POST;
	}
	function clean($str) {
		$str = @trim($str);
		if(get_magic_quotes_gpc()) {
			$str = stripslashes($str);
		}
		return mysql_real_escape_string($str);
	}
	function get($var = NULL, $clean = true){
		if( array_key_exists($var, $this->_get) ) {
			if($clean){
				return $this->clean($this->_get[$var]);
			} else {
				return $this->_get[$var];
			}
		} else {
			return FALSE;
		}
	}
	function get_all($clean = true){
		$return = array();
		if($clean){
			foreach ($this->_get as $r){
				$return[] = $this->clean($r);
			}
		} else {
			$return = $this->_get;
		}
		return $return;
	}
	function post($var = NULL, $clean = true){
		if( array_key_exists($var, $this->_post) ) {
			if($clean){
				return $this->clean($this->_post[$var]);
			} else {
				return $this->_post[$var];
			}
			
		} else {
			return FALSE;
		}
	}
	function post_all($clean = true){
		$return = array();
		if($clean){
			foreach ($this->_post as $r){
				$return[] = $this->clean($r);
			}
		} else {
			$return = $this->_post;
		}
		return $return;
	}
}

class Helpers {
	function clean($str) {
		$str = @trim($str);
		if(get_magic_quotes_gpc()) {
			$str = stripslashes($str);
		}
		return mysql_real_escape_string($str);
	}
	
	function convert_to_number($str)
	{
		$str = trim($str);
		$holder_array = str_split($str);
		$holder_str = '';
		foreach($holder_array as $holder)
		{
			if (preg_match("/[0-9]/", $holder))
			{
				$holder_str .= $holder;
			}
		}
	
		return $holder_str;
	}
	
	function spamcheck($field){
		$field=filter_var($field, FILTER_SANITIZE_EMAIL);
		if(filter_var($field, FILTER_VALIDATE_EMAIL)){
			return true;
		} else {
			return false;
		}
	}
	
	function html_email($from, $to, $subject, $text, $html){
		$headers = "From: " . $from . "\r\n";
		if(mail($to, $subject, $text, $headers)) {
			return true;
		} else {
			return false;
		}
	}
	
	function convert_date($date){
		$segment = explode('/', $date);
		return mktime(0, 0, 0, intval($segment[1])  , intval($segment[0]), intval($segment[2]));
	}

	function valid_file_extension($name){
		$allowed_extensions = explode(',', APP_ALLOWED_FILE_EXTENSIONS);
		$extension = strtolower($this->get_extension($name));
		if (in_array($extension, $allowed_extensions, TRUE)){
			return true;
		} else {
			return false;
		}
		
		return true;
	}
	
	function get_extension($filename){
		$x = explode('.', $filename);
		return end($x);
	}
	
	function set_filename($path, $filename){
		$filename = $this->clean_file_name($filename);
		$file_ext = $this->get_extension($filename);
		if ( ! file_exists($path.$filename))
		{
			return $filename;
		}
		$new_filename = str_replace('.'.$file_ext, '', $filename);
		for ($i = 1; $i < 300; $i++)
		{			
			if ( ! file_exists($path.$new_filename.'_'.$i.'.'.$file_ext))
			{
				$new_filename .= '_'.$i.'.'.$file_ext;
				break;
			}
		}
		return $new_filename;
	}
	
	function clean_file_name($filename){
		$invalid = array("<!--","-->","'","<",">",'"','&','$','=',';','?','/',"%20","%22","%3c","%253c","%3e","%0e","%28","%29","%2528","%26","%24","%3f","%3b", "%3d");		
		$filename = str_replace($invalid, '', $filename);
		$filename = preg_replace("/\s+/", "_", $filename);
		return stripslashes($filename);
	}
	
	function create_url($function , $arguments = array()){
		$url = '';
		
		if(APP_HUMAN_FRIENDLY_URL == true){
			$url = APP_BASE_URL . $function  . '/';
			foreach($arguments as $a){
				$url .= $a . '/';
			}
		} else {
			$url = APP_BASE_URL . 'index.php?function=' . $function;
			$i = 0;
			while($i < count($arguments)){
				$url .= '&arg_' . $i . '=' . $arguments[$i];
				$i++;
			}
		}
		
		return $url;
	}
}