<?php if ( ! defined('APP_ABSPATH')) exit('No direct script access allowed');
/*
*	ALL THE INTERACTIONS WITH THE DATABASE ARE HANDLED IN THIS CLASS
*/
class Model {
	var $db_connection;
	var $spaces_table;
	var $prices_table;
	var $adverts_table;
	var $pending_table;
	var $impressions_table;
	var $clicks_table;
	var $users_table;
	
	// The constructor method opend the database connection
	function Model(){
		$this->spaces_table = APP_TABLES_PREFIX . 'spaces';
		$this->prices_table = APP_TABLES_PREFIX . 'prices';
		$this->adverts_table = APP_TABLES_PREFIX . 'adverts';
		$this->pending_table = APP_TABLES_PREFIX . 'pending';
		$this->impressions_table = APP_TABLES_PREFIX . 'impressions';
		$this->clicks_table = APP_TABLES_PREFIX . 'clicks';
		$this->users_table = APP_TABLES_PREFIX . 'users';
		
		$result = false;
		$this->db_connection = mysql_connect(APP_DB_HOST, APP_DB_USER, APP_DB_PASSWORD);
		if($this->db_connection){
			$seldb = mysql_select_db(APP_DB_NAME,$this->db_connection);
			if($seldb){
				$result = true;
			}
		}
		return $result;
	}
	
	function disconnect() {
		return  mysql_close($this->db_connection);
	}
	
	/*
	*	THE FOLLOWING ARE THE METHODS CALLED FROM THE CONTROLLER CLASS.
	*	THEIR NAMES EXPRESS WHAT THEY DO.
	*	THEY ALL MAKE USE A CRUD METHOD FOR SELECT, UPDATE, INSERT AND DELETE AT THE END PARTS OF THIS CLASS
	*/
	
	/*
	*	GENERAL SLOT FUNCTIONS
	*/
	function get_paged_slots($offset, $rows){
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->spaces_table, '*', null, null, $limit, $condition = 'AND');
	}
	function count_slots(){
		return count($this->select($this->spaces_table, 'id', $where));
	}
	
	
	/*
	*	BANNER SLOTS
	*/
	function create_slot($values){
		$values['advert_type'] = 'banner';
		return $this->insert($this->spaces_table, $values);
	}
	function update_slot($id, $values){
		$where = array('id' => $id);
		return $this->update($this->spaces_table, $values, $where, $condition = 'AND');
	}
	function get_paged_banner_slots($offset, $rows){
		$where = array('advert_type' => 'banner');
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->spaces_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_banner_slots(){
		$where = array('advert_type' => 'banner');
		return count($this->select($this->spaces_table, 'id', $where));
	}
	function get_slot($id){
		$where = array('id' => $id);
		$results = $this->select($this->spaces_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function delete_slot($id){
		$where = array('id' => $id);
		return $this->delete($this->spaces_table, $where, $condition = 'AND');
	}
	function get_all_banner_slots(){
		$where = array('advert_type' => 'banner');
		return $this->select($this->spaces_table, '*', $where, null, null, $condition = 'AND');
	}
	
	
	/*
	*	GENERAL ADVERT FUNCTIONS
	*/
	function create_advert($values){
		return $this->insert($this->adverts_table, $values);
	}
	function get_advert($id){
		$where = array('id' => $id);
		$results = $this->select($this->adverts_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function update_advert($id, $values){
		$where = array('id' => $id);
		return $this->update($this->adverts_table, $values, $where, $condition = 'AND');
	}
	function delete_advert($id){
		$where = array('id' => $id);
		return $this->delete($this->adverts_table, $where, $condition = 'AND');
	}
	function count_slot_adverts($id){
		$where = array('group_or_slot_id ' => $id);
		$results = $this->select($this->adverts_table, '*', $where, null, null, $condition = 'AND');
		return count($results);
	}
	function get_slot_runnning_adverts($id){
		$where = array('group_or_slot_id ' => $id, 'stopped' => 'n');
		$results = $this->select($this->adverts_table, '*', $where, null, null, $condition = 'AND');
		return $results;
	}
	
	
	/*
	*	BANNER ADVERTS
	*/
	function get_paged_banner_adverts($offset, $rows){
		$where = array('advert_type' => 'banner');
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->adverts_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_banner_adverts(){
		$where = array('advert_type' => 'banner');
		return count($this->select($this->adverts_table, 'id', $where));
	}
	function get_advertisers_paged_adverts($offset, $rows, $user_id){
		$where = array('advertiser_id ' => $user_id);
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->adverts_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_advertisers_adverts($user_id){
		$where = array('advertiser_id ' => $user_id);
		return count($this->select($this->adverts_table, 'id', $where));
	}
	
	/*
	*	TEXTLINKS
	*/
	function get_paged_textlink($offset, $rows){
		$where = array('advert_type' => 'textlink');
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->adverts_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_textlinks(){
		$where = array('advert_type' => 'textlink');
		return count($this->select($this->adverts_table, 'id', $where));
	}
	
	/*
	*	PRICES
	*/
	function create_price($values){
		return $this->insert($this->prices_table, $values);
	}
	function delete_price($id){
		$where = array('id' => $id);
		return $this->delete($this->prices_table, $where, $condition = 'AND');
	}
	function delete_slot_prices($id){
		$where = array('space_id' => $id);
		return $this->delete($this->prices_table, $where, $condition = 'AND');
	}
	function get_slot_prices($slot_id){
		$where = array('space_id' => $slot_id);
		$order_by = array('id' => 'ASC');
		return $this->select($this->prices_table, '*', $where, $order_by, null, $condition = 'AND');
	}
	function get_slot_prices_order_by_price($slot_id){
		$where = array('space_id' => $slot_id);
		$order_by = array('price' => 'ASC');
		return $this->select($this->prices_table, '*', $where, $order_by, null, $condition = 'AND');
	}
	function get_price($id){
		$where = array('id' => $id);
		$results = $this->select($this->prices_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function get_slot_prices_to_extend($values){
		$order_by = array('price' => 'ASC');
		return $this->select($this->prices_table, '*', $values, $order_by, null, $condition = 'AND');
	}
	
	/*
	*	TEXTLINK CATEGORIES
	*/
	function create_category($values){
		$values['advert_type'] = 'textlink';
		return $this->insert($this->spaces_table, $values);
	}
	function update_category($id, $values){
		$where = array('id' => $id);
		return $this->update($this->spaces_table, $values, $where, $condition = 'AND');
	}
	function get_paged_textlink_categories($offset, $rows){
		$where = array('advert_type' => 'textlink');
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->spaces_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_textlink_categories(){
		$where = array('advert_type' => 'textlink');
		return count($this->select($this->spaces_table, 'id', $where));
	}
	function get_category($id){
		$where = array('id' => $id);
		$results = $this->select($this->spaces_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function delete_category($id){
		$where = array('id' => $id);
		return $this->delete($this->spaces_table, $where, $condition = 'AND');
	}
	function get_all_categories(){
		$where = array('advert_type' => 'textlink');
		return $this->select($this->spaces_table, '*', $where, null, null, $condition = 'AND');
	}
	
	/*
	*	PENDING
	*/
	function get_paged_pending($offset, $rows){
		$where = array('approved' => 'n', 'rejected' => 'n');
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->pending_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_pending(){
		$where = array('approved' => 'n', 'rejected' => 'n');
		return count($this->select($this->pending_table, 'id', $where));
	}
	function get_paged_rejected($offset, $rows){
		$where = array('rejected' => 'y');
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->pending_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_rejected(){
		$where = array('rejected' => 'y');
		return count($this->select($this->pending_table, 'id', $where));
	}
	function get_paged_approved($offset, $rows){
		$where = array('approved' => 'y');
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->pending_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_approved(){
		$where = array('approved' => 'y');
		return count($this->select($this->pending_table, 'id', $where));
	}
	function create_pending($values){
		return $this->insert($this->pending_table, $values);
	}
	function update_pending($id, $values){
		$where = array('id' => $id);
		return $this->update($this->pending_table, $values, $where, $condition = 'AND');
	}
	function get_pending($id){
		$where = array('id' => $id);
		$results = $this->select($this->pending_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function delete_pending($id){
		$where = array('id' => $id);
		return $this->delete($this->pending_table, $where, $condition = 'AND');
	}
	
	/*
	*	CLICKS AND IMPRESSIONS
	*/
	function get_advert_daily_stats($id){
		$return = array();
		$i = 0;
		$now = time();
		while ($i <= 30){
			$diff = 30 - $i;
			$the_date = $now - (intval($diff) * 24 * 60 * 60);
			$return[$i]['long_date'] =  date("d/m/Y", $the_date);
			$date_to_check = $return[$i]['long_date'];
			$return[$i]['short_date'] =  date("d", $the_date);
			$return[$i]['timestamp'] =  $the_date*1000;
			$where = array('date_time' => $date_to_check, 'advert' => $id);
			$qry = $this->select($this->impressions_table, '*', $where);
			if($qry)
			{
				$result_count = count($qry);
				if($result_count > 0)
				{
					$return[$i]['impressions'] =  $qry[0]['total'];
				} else {
					$return[$i]['impressions'] =  0;
				}
			} else {
				$return[$i]['impressions'] =  0;
			}
			$qry = $this->select($this->clicks_table, '*', $where);
			if($qry)
			{
				$result_count = count($qry);
				if($result_count > 0)
				{
					$return[$i]['clicks'] =  $qry[0]['total'];
				} else {
					$return[$i]['clicks'] =  0;
				}
			} else {
				$return[$i]['clicks'] =  0;
			}
			$i++;
		}
		return $return;
	}
	
	function update_impressions($advert){
		$impressions = $advert['impressions'];
		$impressions++; 
		$this->update($this->adverts_table, array('impressions'=>$impressions), array('id'=>$advert['id']), $condition = 'AND');
		$time_now = date("d/m/Y");
		$where = array('date_time' => $time_now, 'advert' => $advert['id']);
		$qry = $this->select($this->impressions_table, '*', $where);
		if($qry){
			$hits = $qry[0]['total'] + 1;
			$this->update($this->impressions_table, array('total'=>$hits), array('id'=>$qry[0]['id']), $condition = 'AND');
		} else {
			$this->insert($this->impressions_table,array('date_time' => $time_now, 'advert' => $advert['id'], 'total' => 1));
		}
		return true;
	}
	
	function update_clicks($advert){
		$clicks = $advert['clicks'];
		$clicks++; 
		$this->update($this->adverts_table, array('clicks'=>$clicks), array('id'=>$advert['id']), $condition = 'AND');
		$time_now = date("d/m/Y");
		$where = array('date_time' => $time_now, 'advert' => $advert['id']);
		$qry = $this->select($this->clicks_table, '*', $where);
		if($qry){
			$hits = $qry[0]['total'] + 1;
			$this->update($this->clicks_table, array('total'=>$hits), array('id'=>$qry[0]['id']), $condition = 'AND');
		} else {
			$this->insert($this->clicks_table,array('date_time' => $time_now, 'advert' => $advert['id'], 'total' => 1));
		}
		return true;
	}
		
	
	function get_latest_impression($advert){
		$imp_table = $this->impressions_table;
		$advert = $advert;
		$time_now = date("d/m/Y");
		$total = 0;
		
		$where = array('date_time' => $time_now, 'advert' => $id);
		$qry = $this->select($this->impressions_table, '*', $where);
		
		if($qry){
			$total = $qry[0]['total'];
		}
		return $total;
	}
	
	
	/*
	*	USERS
	*/
	function create_user($values){
		return $this->insert($this->users_table, $values);
	}
	function get_user($id){
		$where = array('id' => $id);
		$results = $this->select($this->users_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function get_user_using_email($email){
		$where = array('email' => $email);
		$results = $this->select($this->users_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function update_user($id, $values){
		$where = array('id' => $id);
		return $this->update($this->users_table, $values, $where, $condition = 'AND');
	}
	function delete_user($id){
		$where = array('id' => $id);
		return $this->delete($this->users_table, $where, $condition = 'AND');
	}
	function get_paged_users($offset, $rows){
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->users_table, '*', null, null, $limit, $condition = 'AND');
	}
	function count_users(){
		return count($this->select($this->users_table, 'id'));
	}
	function email_exists($email){
		$where = array('email' => $email);
		$results = $this->select($this->users_table, '*', $where, null, null, $condition = 'AND');
		if(count($results) > 0){
			return false;
		} else {
			return true;
		}
	}
	function check_login($username, $password){
		$where = array('email' => $username, 'password' => $password);
		$results = $this->select($this->users_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function check_password($id, $password){
		$where = array('id' => $id, 'password' => $password);
		$results = $this->select($this->users_table, '*', $where, null, null, $condition = 'AND');
		$save_password = $results['0']['password'];
		if($save_password == $password){
			return true;
		} else {
			return false;
		}
	}
	function change_password($id, $password){
		$values = array('password' => $password);
		$where = array('id' => $id);
		return $this->update($this->users_table, $values, $where, $condition = 'AND');
	}
	function get_advertisers(){
		$where = array('role' => 'advertiser');
		return $this->select($this->users_table, '*', $where, null, null, $condition = 'AND');
	}
	
/*
* CRUD FUNCTIONS:  The following functions can be used to make interacting with the database easier
*/
	
	function tableExists($table)
    {
        $tablesInDb = mysql_query('SHOW TABLES FROM '.APP_DB_NAME.' LIKE "'.$table.'"');
        if($tablesInDb){
            if(mysql_num_rows($tablesInDb)==1){
                return true;
            } else {
                return false;
            }
        }
    }
	
	/*
	* This function selects one or more records from a table
	* It takes the following arguments:
	* 		- $table - the table to select from
	*		- $rows_to_select - a string of the rows to select for example "id, name, time,..."
	*		- $where_keys_values - an array where the keys are field names and the values are the values of those fields. This is for the WHERE part of the query
	*		- $order_by - an array where the keys are field names and the values are the direction to order them in. This is for the ORDER BY part of the query.
	*		- $limit - an array like this array('offset'=>0, 'rows'=>10)
	*		- $condition - the condition to be used for the where part of the query
	*/
	
	function select($table, $rows_to_select = '*', $where_keys_values = null, $order_by = null, $limit = null, $condition = 'AND')
    {
        $results = array();
		$q = 'SELECT '.$rows_to_select.' FROM '.$table;
		
		if($where_keys_values != null){
			$where_str = $this->where_array_to_string($where_keys_values, $condition);
			$q .= ' WHERE '.$where_str;
		}
		
		if($order_by != null){
			$order_by_fields = array_keys($order_by);
			$order_by_direction = array_values($order_by);
			$order_by_str = '';
			
			for($i = 0; $i < count($order_by); $i++){
				$order_by_str .= $order_by_fields[$i] . ' ';
				$order_by_str .= $order_by_direction[$i] . ' ';
				if($i != count($order_by)-1) {
                    $order_by_str .= $condition . ', ';
                }
			}
			$q .= ' ORDER BY '.$order_by_str;
		}
		
		if($limit != null){
			$offset = $limit['offset'];
			$rows = $limit['rows'];
			$q .= "  LIMIT $offset, $rows";
		}
		
		$query = mysql_query($q);
        if($query){
            $numResults = mysql_num_rows($query);
            for($i = 0; $i < $numResults; $i++){
				$row = mysql_fetch_array($query);
				$results[] =  $row;
			}
			
		}
		return $results;
	}
	
	/*
	*This function creates a new MySql records.
	*It takes two arguments:
	*		- $table: the table to insert into
	*		- $keys_values: the values to insert. The keys of the array should be the field names
	*It return the id of the new record
	*/
	function insert($table, $keys_values)
    {
        if($this->tableExists($table)){
            $insert = 'INSERT INTO '.$table;
            $rows = array_keys($keys_values);
			$rows = implode(', ',$rows);
			
			if($rows != null){
                $insert .= ' ('.$rows.')';
            }
			
			$values = array_values($keys_values);

            for($i = 0; $i < count($values); $i++){
                if(is_string($values[$i]))
                    $values[$i] = '"'.$values[$i].'"';
				if(strlen($values[$i])== 0)
                    $values[$i] = 'NULL';
            }
            $values = implode(', ',$values);
            $insert .= ' VALUES ('.$values.')';

            $ins = mysql_query($insert);

            if($ins){
                return mysql_insert_id();
            } else {
                return 0;
            }
        }
    }
	
	
    /*
	*This function updates the database with the values sent
	*It takes four arguments:
	*		- $table: the table to insert into
	*		- $keys_values: the values to update. The keys of the array should be the field names
	*		- $where_keys_values: the values for the WHERE part of the query. The keys of the array should be the field names
	*		- $condition: AND or OR
	*It return true or false
	*/
    function update($table, $keys_values, $where_keys_values, $condition = 'AND')
    {
        if($this->tableExists($table))
        {
            $where_str = $this->where_array_to_string($where_keys_values, $condition);
			
			$update = 'UPDATE '.$table.' SET ';
            $keys = array_keys($keys_values);
            for($i = 0; $i < count($keys_values); $i++) {
                if(is_string($keys_values[$keys[$i]])) {
                    $update .= $keys[$i].'="'.$keys_values[$keys[$i]].'"';
                } else {
                    $update .= $keys[$i].'='.$keys_values[$keys[$i]];
                }
				if($i != count($keys_values)-1) {
                    $update .= ',';
                }
            }
			
			
            $update .= ' WHERE '.$where_str;
			$query = mysql_query($update);
            if($query){
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
	
	/*
	*This function simply deletes a table or records
	*If the $where_keys_values argument is not provided then the whole table is deleted
	*/
	function delete($table, $where_keys_values = null, $condition = 'AND')
    {
        if($this->tableExists($table)){
            if($where_keys_values != null){
                $where_str = $this->where_array_to_string($where_keys_values, $condition);
				$delete = 'DELETE FROM '.$table.' WHERE '.$where_str;
				$del = mysql_query($delete);
				if($del) {
					return true;
				} else {
					return false;
				}
			}
        }
		return false;
    }
	
	/*
	*	This method converts an array that has field names and values to a string that can be put in the WHERE section of a mysql query
	*	It also places the condition (AND || OR) in the string
	*/
	function where_array_to_string($where_keys_values, $condition){
		$where_fields = array_keys($where_keys_values);
		$where_values = array_values($where_keys_values);
		$where_str = '';
			
		for($i = 0; $i < count($where_keys_values); $i++){
			$where_str .= $where_fields[$i] . ' = ';
			if(is_string($where_values[$i])){
				$where_str .= '"' . $where_values[$i] . '" ';
			} else {
				$where_str .= $where_values[$i] . ' ';
			}
			if($i != count($where_keys_values)-1) {
				$where_str .= $condition . ' ';
			}
		}
		
		return $where_str;
	}
}