<?php
/** MySQL database name */
define('APP_DB_NAME', '');

/** MySQL database username */
define('APP_DB_USER', '');

/** MySQL database password */
define('APP_DB_PASSWORD', '');

/** MySQL hostname */
define('APP_DB_HOST', '');

/** MySQL hostname */
define('APP_TABLES_PREFIX', 'sa_');


Class Simple_advert{
	function Simple_advert(){
		$this->adverts_table = APP_TABLES_PREFIX . 'adverts';
		$this->impressions_table = APP_TABLES_PREFIX . 'impressions';
		
		$result = false;
		$this->db_connection = mysql_connect(APP_DB_HOST, APP_DB_USER, APP_DB_PASSWORD);
		if($this->db_connection){
			$seldb = mysql_select_db(APP_DB_NAME,$this->db_connection);
			if($seldb){
				$result = true;
			}
		}
		return $result;
	}
	
	function disconnect() {
		return  mysql_close($this->db_connection);
	}
	
	function count_textlinks_for_group($id){
		$count = 0;
		$where = array('advert_type' => 'textlink','group_or_slot_id'=>$id);
		$records = $this->select($this->adverts_table, 'id', $where);
		for($i = 0; $i < count($records); $i++){
			if($this->is_live($records[$i])){
				$count++;
			}
		}
		return $count;
	}
	
	function get_textlinks_for_group($slot){
		$results = array();
		$where = array('advert_type' => 'textlink','group_or_slot_id'=>$slot);
		$records = $this->select($this->adverts_table, '*', $where);
		for($i = 0; $i < count($records); $i++){
			if($this->is_live($records[$i])){
				$this->update_impressions($records[$i]);
				$results[$i]['html_id'] = 'simple_textlink_'.$records[$i]['id'];
				$results[$i]['title'] = $records[$i]['title'];
				$results[$i]['url'] = $records[$i]['destination_url'];
				$results[$i]['anchor'] = '<a href="'.$records[$i]['destination_url'].'" rel="simple_textlink" id="simple_textlink_'.$records[$i]['id'].'">'.$records[$i]['title'].'</a>';
				$results[$i]['rel'] = 'simple_textlink';
				
			}
		}
		
		return $results;
	}
	
	function get_textlinks_as_list($slot, $ordered = false){
		$links = $this->get_textlinks_for_group($slot);
		$list = '';
		foreach($links as $link){
			$list .= '<li>' . $link['anchor'] .  '</li>';
		}
		
		if($ordered){
			return '<ol>' . $list . '</ol>';
		} else {
			return '<ul>' . $list . '</ul>';
		}
	}
	
	function is_live($banner){
		$islive = true;
		
		if($banner['stopped'] == 'y'){
			$islive = false;
		}
		if($banner['enddate']){
			if($banner['enddate'] < time())
				$islive = false;
		}
		if($banner['maximpressions']){
			if($banner['impressions'] >= $banner['maximpressions'])
				$islive = false;
		}
		if($banner['maxclicks']){
			if($banner['clicks'] >= $banner['maxclicks'])
				$islive = false;
		}

		return $islive;
	}
	
	function update_impressions($advert){
		$impressions = $advert['impressions'];
		$impressions++;
		$this->update($this->adverts_table, array('impressions' => $impressions), array('id' => $advert['id']), $condition = 'AND');
		
		$time_now = date("d/m/Y");
		$records = $this->select($this->impressions_table, '*', array('advert'=>$advert['id'], 'date_time'=>$time_now));
		
		if(count($records) > 0){
			$hits = $records[0]['total'] + 1;
			$this->update($this->impressions_table, array('total' => $hits), array('id' => $records[0]['id']), $condition = 'AND');
		} else {
			$this->insert($this->impressions_table, array('advert'=>$advert['id'], 'date_time'=>$time_now, 'total' => 1));
		}
		return true;
	}
	
	/*
	* This function selects one or more records from a table
	* It takes the following arguments:
	* 		- $table - the table to select from
	*		- $rows_to_select - a string of the rows to select for example "id, name, time,..."
	*		- $where_keys_values - an array where the keys are field names and the values are the values of those fields. This is for the WHERE part of the query
	*		- $order_by - an array where the keys are field names and the values are the direction to order them in. This is for the ORDER BY part of the query.
	*		- $limit - an array like this array('offset'=>0, 'rows'=>10)
	*		- $condition - the condition to be used for the where part of the query
	*/
	
	function tableExists($table)
    {
        $tablesInDb = mysql_query('SHOW TABLES FROM '.APP_DB_NAME.' LIKE "'.$table.'"');
        if($tablesInDb){
            if(mysql_num_rows($tablesInDb)==1){
                return true;
            } else {
                return false;
            }
        }
    }
	
	function select($table, $rows_to_select = '*', $where_keys_values = null, $order_by = null, $limit = null, $condition = 'AND'){
        $results = array();
		$q = 'SELECT '.$rows_to_select.' FROM '.$table;
		
		if($where_keys_values != null){
			$where_str = $this->where_array_to_string($where_keys_values, $condition);
			$q .= ' WHERE '.$where_str;
		}
		
		if($order_by != null){
			$order_by_fields = array_keys($order_by);
			$order_by_direction = array_values($order_by);
			$order_by_str = '';
			
			for($i = 0; $i < count($order_by); $i++){
				$order_by_str .= $order_by_fields[$i] . ' ';
				$order_by_str .= $order_by_direction[$i] . ' ';
				if($i != count($order_by)-1) {
                    $order_by_str .= $condition . ', ';
                }
			}
			$q .= ' ORDER BY '.$order_by_str;
		}
		
		if($limit != null){
			$offset = $limit['offset'];
			$rows = $limit['rows'];
			$q .= "  LIMIT $offset, $rows";
		}
		
		$query = mysql_query($q);
        if($query){
            $numResults = mysql_num_rows($query);
            for($i = 0; $i < $numResults; $i++){
				$row = mysql_fetch_array($query);
				$results[] =  $row;
			}
			
		}
		return $results;
	}
	
	/*
	*This function creates a new MySql records.
	*It takes two arguments:
	*		- $table: the table to insert into
	*		- $keys_values: the values to insert. The keys of the array should be the field names
	*It return the id of the new record
	*/
	function insert($table, $keys_values){
        if($this->tableExists($table)){
            $insert = 'INSERT INTO '.$table;
            $rows = array_keys($keys_values);
			$rows = implode(', ',$rows);
			
			if($rows != null){
                $insert .= ' ('.$rows.')';
            }
			
			$values = array_values($keys_values);

            for($i = 0; $i < count($values); $i++){
                if(is_string($values[$i]))
                    $values[$i] = '"'.$values[$i].'"';
            }
            $values = implode(', ',$values);
            $insert .= ' VALUES ('.$values.')';

            $ins = mysql_query($insert);

            if($ins){
                return mysql_insert_id();
            } else {
                return 0;
            }
        }
    }
	
	
    /*
	*This function updates the database with the values sent
	*It takes four arguments:
	*		- $table: the table to insert into
	*		- $keys_values: the values to update. The keys of the array should be the field names
	*		- $where_keys_values: the values for the WHERE part of the query. The keys of the array should be the field names
	*		- $condition: AND or OR
	*It return true or false
	*/
    function update($table, $keys_values, $where_keys_values, $condition = 'AND'){
        if($this->tableExists($table))
        {
            $where_str = $this->where_array_to_string($where_keys_values, $condition);
			
			$update = 'UPDATE '.$table.' SET ';
            $keys = array_keys($keys_values);
            for($i = 0; $i < count($keys_values); $i++) {
                if(is_string($keys_values[$keys[$i]])) {
                    $update .= $keys[$i].'="'.$keys_values[$keys[$i]].'"';
                } else {
                    $update .= $keys[$i].'='.$keys_values[$keys[$i]];
                }
				if($i != count($keys_values)-1) {
                    $update .= ',';
                }
            }
			
			
            $update .= ' WHERE '.$where_str;
			$query = mysql_query($update);
            if($query){
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
	
	
	
	/*
	*	This method converts an array that has field names and values to a string that can be put in the WHERE section of a mysql query
	*	It also places the condition (AND || OR) in the string
	*/
	function where_array_to_string($where_keys_values, $condition){
		$where_fields = array_keys($where_keys_values);
		$where_values = array_values($where_keys_values);
		$where_str = '';
			
		for($i = 0; $i < count($where_keys_values); $i++){
			$where_str .= $where_fields[$i] . ' = ';
			if(is_string($where_values[$i])){
				$where_str .= '"' . $where_values[$i] . '" ';
			} else {
				$where_str .= $where_values[$i] . ' ';
			}
			if($i != count($where_keys_values)-1) {
				$where_str .= $condition . ' ';
			}
		}
		
		return $where_str;
	}
	
}

?>